// Created by Josh Heyde
// Last updated 27/01/09

#pragma once

#include <vector>

// forward declaration
class C_Wave;
class C_Route;
class C_WorldEntity;

class C_AI
{
public:
	//destructor
	~C_AI();

	// other member functions

	// intialises the component
	bool intialise(std::vector <C_WorldEntity*> v_entityVector);

	// updates the AI component
	void update(std::vector <C_WorldEntity*> v_entityVector, const float &currentTime);

	// create singleton
	static void createAI(const int &numOfRoutes, const int &fBE, const int &lBE, const int &fAE, const int &lAE);
	// get singleton
	static C_AI& getAI() {return *ai;}
	// delete singleton
	static void deleteAI();
protected:
	// constructor
	C_AI(const int &numOfRoutes, const int &fBE, const int &lBE, const int &fAE, const int &lAE);

	// singleton
	static C_AI* ai;

	// vectors to hold the routes and waves respectively
	std::vector <C_Wave*> v_waveVector;
	std::vector <C_Route*> v_routeVector;

	// holds the number of routes and waves to initially create
	const int NUM_OF_ROUTES;

	// holds the ranges of enemies
	int firstBasicEnemy;
	int lastBasicEnemy;
	int firstAdvancedEnemy;
	int lastAdvancedEnemy;

	// stores the current wave being used
	int currentWave;

	// sets up the delay for spawning enemies
	float previousTime;
	const float DELAY;
};

#define AI C_AI::getAI()
