// Created by Josh Heyde
// Last updated 27/01/09

#pragma once

#include <vector>

// forward declaration
class C_Vector;

using namespace std;

class C_Route
{
public:
	C_Route(string file);
	~C_Route();

	// accessor and mutator functions
	const string getFileName() const {return fileName;}
	void setFileName(const string &newFileName);
	const int getNumOfWayPoints() const {return numOfWayPoints;}
	void setNumOfWayPoints(const int &newNumOfWayPoints);

	// other member functions

	// returns a specific waypoint
	C_Vector* getWayPoint(const int &id) const {return v_wayPointVector[id];}

	// initialises the route by reading from the file
	bool initialise();
private:
	std::vector <C_Vector*> v_wayPointVector;
	string fileName;
	int numOfWayPoints;
};
