// Created by Josh Heyde
// Last updated 27/01/09

#pragma once


#include <vector>

// forward declarations
class C_WorldEntity;
class C_Route;

class C_Wave
{
public:
	C_Wave(const int &rRef, const int &id1, const int &id2, const int &id3, const int &id4, const int &id5);
	~C_Wave();

	// accessor and mutator functions
	const int getEnemyToSpawn() const {return enemyToSpawn;}
	void setEnemyToSpawn(const int &newEnemyToSpawn);
	const int getNumOfEnemies() const {return numOfEnemies;}
	void setNumOfEnemies(const int &newNumOfEnemies);
	const int getRouteReference() const {return routeReference;}
	void setRouteReference(const int & newRouteReference);
	
	// other member functions
	bool intialise(std::vector<C_WorldEntity*> v_entityVector, const C_Route* route);

	// spawns an enemy from the wave
	void spawnEnemy(std::vector <C_WorldEntity*> v_entityVector);

	// checks to see if the wave has been completed
	bool isWaveComplete(std::vector <C_WorldEntity*> v_entityVector) const;

	// checks to see if all enemies have been spawned
	const bool allEnemiesSpawned() const;
	
	// sets the next waypoint for a specific entity
	void getNextWayPoint(std::vector <C_WorldEntity*> v_entityVector, const int &id, const C_Route* route);
	
	// updates the wave
	void update(std::vector <C_WorldEntity*> v_entityVector, const C_Route* route);

	// resets the wave for reuse
	void resetWave(std::vector<C_WorldEntity*> v_entityVector);
private:
	int routeReference;
	std::vector <int> v_enemyIDVector;
	int enemyToSpawn;
	int numOfEnemies;
};
